<template lang="pug">
footer.fp-auto-height.footer.section#footer(
  :class="{'footer--blue': blue}"
)
  header-block.footer__header.header--hide-lang(
    :fullwhite="blue"
  )
  .container
    .footer-top
      .footer-top__left(v-if="settings.phone || settings.phone_2")
        .footer__callback
          p {{ $t('footer.callUs') }}
          .footer__phones
            a(
              v-if="settings.phone"
              :href="settings.phone | phoneUrl"
              @click="firePhoneClick(settings.phone, 'tel-msk')"
            ) {{ settings.phone }}
            a(
              v-if="settings.phone_2"
              :href="settings.phone_2 | phoneUrl"
              @click="firePhoneClick(settings.phone_2, 'tel-gb')"
            ) {{ settings.phone_2 }}

      .footer-top__right(v-if="settings.public_email")
        a.footer__email(
          :href="'mailto:' + settings.public_email"
          @click="fireEmailClick(settings.public_email, 'email')"
        ) {{ settings.public_email }}

    .footer-bottom
      .footer-bottom__left
        small.copyright(v-if="settings.copyrights" v-html="settings.copyrights")

      .footer-bottom__center
        .footer__dev
          | {{ $t('footer.developedBy') }} —
          |
          a(href="https://facedigital.ru/" target="_blank") FACE digital agency

      .footer-bottom__right(v-if="menus && menus.SOCIALS_MENU && menus.SOCIALS_MENU.items.length")
        socials(:classes="{ 'social--large': true, 'social--white': blue }")
</template>

<script>
import { mapGetters, mapState } from 'vuex'
import { phoneUrl, url } from '@/filters'
import config from '@/config'
import { execMetrikaMethod } from '@/utils/metrika'

export default {
  name: 'FooterBlock',

  computed: {
    activeLocale () {
      return this.locales.filter(locale => {
        return locale.text === this.locale
      })
    },
    locales () {
      return config.locales.map(l => {
        return {
          verbose: l,
          url: this.replaceURLByLocale(l),
          text: l,
          value: this.replaceURLByLocale(l)
        }
      })
    },
    ...mapState({
      locale: state => state.locale
    }),
    ...mapGetters({
      menus: 'vars/menus',
      settings: 'vars/settings'
    })
  },

  filters: { phoneUrl, url },

  methods: {
    changeLocale (value) {
      window.location.href = value
    },

    fireEmailClick (email, action) {
      execMetrikaMethod('reachGoal', [action])
    },

    firePhoneClick (phone, action) {
      execMetrikaMethod('reachGoal', [action])
    },

    replaceURLByLocale (locale) {
      const urlParts = this.$route.fullPath.split('/')
      if (locale === config.locales[0]) {
        urlParts.splice(1, 1)
      } else if (this.locale !== config.locales[0]) {
        urlParts[1] = locale
      } else {
        urlParts.splice(1, 0, locale)
      }

      let res = url(urlParts.join('/'))
      if (res.length > 1 && res[res.length - 1] === '/') {
        res = res.substr(0, res.length - 1)
      }
      return res
    }
  },

  props: {
    blue: {
      type: Boolean,
      required: false
    }
  }
}
</script>
